#!/bin/bash
LANG=c
############################################
#  Ver.1.0.0  2010/04/21  Support with MegaCLI Ver.5.00.14
#  Ver.1.0.1  2010/04/23  Support with MegaCLI Ver.5.00.14
#  Ver.1.1.2  2010/05/11  Support with MegaCLI Ver.5.00.14
#  Ver.1.1.3  2010/12/09  Support with MegaCLI Ver.5.00.14
#  Ver.1.1.4  2010/12/09  Support with MegaCLI Ver.5.00.14
#  Ver.1.2.1  2011/01/27  Support with MegaCLI Ver.5.00.14
#  Ver.1.2.1  2011/01/31  Support with MegaCLI Ver.5.00.14
#  Ver.2.3.0  2011/02/02  Support with MegaCLI Ver.8.00.00 for VMwareESX 4.0
############################################

###############################
### Shell Variable
###############################

# Failed Flag : 0=OK, 1=NG
FAIL_FLG=0

OUTPUT_LOG=/var/log/mg_refr.log

# A1.1.0 Directory & Filename of MegaCli
MEGACLI_DIR=/opt/nec/refresh/
MEGACLI_NAME=""
Retry=3600

###############################
### MegaCli Filename Select  A1.1.0
###############################

#uname -m | grep 'x86_64' > /dev/null    # x64
#if [ $? -eq 0 ]; then
#  MEGACLI_NAME=MegaCli64
#else
  MEGACLI_NAME=MegaCli
#fi

###############################
### Install check
###############################

if [ -f /opt/nec/refresh/Registration.sh ]; then
:
else
echo "`date`  Registration.sh file is not found in /opt/nec/refresh." >> $OUTPUT_LOG 2>&1
     echo ""
     echo "Registration.sh file is not found in /opt/nec/refresh."
     echo ""
exit 1
fi

if [ -f /opt/nec/refresh/mg_refr.sh ]; then
:
else
echo "`date`  mg_refr.sh file is not found in /opt/nec/refresh." >> $OUTPUT_LOG 2>&1
     echo ""
     echo "mg_refr.sh file is not found in /opt/nec/refresh."
     echo ""
exit 1
fi

if [ -f /opt/nec/refresh/$MEGACLI_NAME ]; then
:
else
echo "`date`  $MEGACLI_NAME file is not found in /opt/nec/refresh." >> $OUTPUT_LOG 2>&1
     echo ""
     echo "$MEGACLI_NAME file is not found in /opt/nec/refresh."
     echo ""
exit 1
fi


########################################################
for i in `seq 0 3`

do

########iBBU############################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$i | grep "BBU             : Present" > /dev/null
if [ $? -eq 0 ]; then
    # echo "Adapate$i cron taisyou"

########Ruch############################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$i | grep "SubDeviceId     : 1013" > /dev/null
   if [ $? -eq 0 ]; then
    ## cron Ruchbah touroku
    echo "$i 0 1-7 2,5,8,11 * [ \"\$(date '+\\%w')\" -eq 0 ] && \`/opt/nec/refresh/mg_refr.sh $i\`" >> /var/spool/cron/root
     if [ $? -eq 0 ]; then
      echo "`date`  Adapter$i:Battery refresh schdule is Registered." >> $OUTPUT_LOG 2>&1
     # echo "Adapate$i Ruchbah"
     else
      echo "`date`  Adapter$i:Battery refresh schdule is failed to be registered." >> $OUTPUT_LOG 2>&1
     fi
   else 
#########Caph###########################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$i | grep "SubDeviceId     : 1016" > /dev/null
   if [ $? -eq 0 ]; then
    ## cron Caph touroku
    echo "$i 0 1-7 2,5,8,11 * [ \"\$(date '+\\%w')\" -eq 0 ] && \`/opt/nec/refresh/mg_refr.sh $i\`" >> /var/spool/cron/root
     if [ $? -eq 0 ]; then
      echo "`date`  Adapter$i:Battery refresh schdule is Registered." >> $OUTPUT_LOG 2>&1
     # echo "Adapate$i Caph"
     else
      echo "`date`  Adapter$i:Battery refresh schdule is failed to be registered." >> $OUTPUT_LOG 2>&1
     fi
   else
#########Foxc###########################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$i | grep "SubDeviceId     : 835a" > /dev/null
   if [ $? -eq 0 ]; then
    ## cron Foxc touroku
    echo "$i 0 1-7 2,5,8,11 * [ \"\$(date '+\\%w')\" -eq 0 ] && \`/opt/nec/refresh/mg_refr.sh $i\`" >> /var/spool/cron/root
     if [ $? -eq 0 ]; then
      echo "`date`  Adapter$i:Battery refresh schdule is Registered." >> $OUTPUT_LOG 2>&1
     # echo "Adapate$i Foxcove"
     else
      echo "`date`  Adapter$i:Battery refresh schdule is failed to be registered." >> $OUTPUT_LOG 2>&1
     fi
   else
#########Cast###########################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$i | grep "SubDeviceId     : 9264" > /dev/null
   if [ $? -eq 0 ]; then
    ## cron Cast touroku
    echo "$i 0 1-7 2,5,8,11 * [ \"\$(date '+\\%w')\" -eq 0 ] && \`/opt/nec/refresh/mg_refr.sh $i\`" >> /var/spool/cron/root
     if [ $? -eq 0 ]; then
      echo "`date`  Adapter$i:Battery refresh schdule is Registered." >> $OUTPUT_LOG 2>&1
     # echo "Adapate$i Castor"
     else
      echo "`date`  Adapter$i:Battery refresh schdule is failed to be registered." >> $OUTPUT_LOG 2>&1
     fi
   fi #Cast
   fi #Foxc
   fi #Caph
   fi #Ruch
fi    #iBBU
done
exit 0 

