#!/bin/bash
LANG=c
############################################
#  Ver.1.0.0  2009/06/02  Support with MegaCLI Ver.2.00.11
#  Ver.2.0.0  2010/04/21  Support with MegaCLI Ver.5.00.14
#  Ver.2.0.1  2010/04/23  Support with MegaCLI Ver.5.00.14
#  Ver.2.1.0  2010/04/27  Support with MegaCLI Ver.5.00.14
#  Ver.2.2.0  2011/01/26  Support with MegaCLI Ver.5.00.14
#  Ver.2.2.0  2011/01/31  Support with MegaCLI Ver.5.00.14
#  Ver.2.3.0  2011/02/02  Support with MegaCLI Ver.8.00.00 for VMwareESX 4.0
############################################

###############################
### Shell Variable
###############################

# Failed Flag : 0=OK, 1=NG
FAIL_FLG=0

OUTPUT_LOG=/var/log/mg_refr.log

# A1.1.0 Directory & Filename of MegaCli
MEGACLI_DIR=/opt/nec/refresh/
MEGACLI_NAME=""
Retry=3600

###############################
### MegaCli Filename Select  A1.1.0
###############################

#uname -m | grep 'x86_64' > /dev/null    # x64
#if [ $? -eq 0 ]; then
#  MEGACLI_NAME=MegaCli64
#else
  MEGACLI_NAME=MegaCli
#fi

###############################
### Install check
###############################

if [ -f /opt/nec/refresh/Registration.sh ]; then
:
else
echo "`date`  Registration.sh file is not found in /opt/nec/refresh." >> $OUTPUT_LOG 2>&1
     echo ""
     echo "Registration.sh file is not found in /opt/nec/refresh."
     echo ""
exit 1
fi

if [ -f /opt/nec/refresh/mg_refr.sh ]; then
:
else
echo "`date`  mg_refr.sh file is not found in /opt/nec/refresh." >> $OUTPUT_LOG 2>&1
     echo ""
     echo "mg_refr.sh file is not found in /opt/nec/refresh."
     echo ""
exit 1
fi

if [ -f /opt/nec/refresh/$MEGACLI_NAME ]; then
:
else
echo "`date`  $MEGACLI_NAME file is not found in /opt/nec/refresh." >> $OUTPUT_LOG 2>&1
     echo ""
     echo "$MEGACLI_NAME file is not found in /opt/nec/refresh."
     echo ""
exit 1
fi


###################################
for i in `seq 0 3`
do
  if [ $i -ne 0 ]; then
    echo "`date`  Adapter$1:Battery refresh fail.(Loop $i)" >> $OUTPUT_LOG 2>&1
    echo "Adapter$1:Sleep 3600sec"
    sleep $Retry
  fi
########Ruch############################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$1 | grep "SubDeviceId     : 1013" > /dev/null
  if [ $? -eq 0 ]; then
    $MEGACLI_DIR$MEGACLI_NAME -AdpBbuCmd -BbuLearn -a$1 > /dev/null
    if [ $? -eq 0 ]; then
    echo "`date`  Adapter$1:Battery refresh start." >> $OUTPUT_LOG 2>&1
    exit 0
    fi
  fi
#########Caph###########################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$1 | grep "SubDeviceId     : 1016" > /dev/null
  if [ $? -eq 0 ]; then
    $MEGACLI_DIR$MEGACLI_NAME -AdpBbuCmd -BbuLearn -a$1 > /dev/null
    if [ $? -eq 0 ]; then
    echo "`date`  Adapter$1:Battery refresh start." >> $OUTPUT_LOG 2>&1
    exit 0
    fi
  fi
#########Foxc###########################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$1 | grep "SubDeviceId     : 835a" > /dev/null
  if [ $? -eq 0 ]; then
    $MEGACLI_DIR$MEGACLI_NAME -AdpBbuCmd -BbuLearn -a$1 > /dev/null
    if [ $? -eq 0 ]; then
    echo "`date`  Adapter$1:Battery refresh start." >> $OUTPUT_LOG 2>&1
    exit 0
    fi
  fi
#########Cast###########################################
  $MEGACLI_DIR$MEGACLI_NAME -AdpAllInfo -a$1 | grep "SubDeviceId     : 9264" > /dev/null
  if [ $? -eq 0 ]; then
    $MEGACLI_DIR$MEGACLI_NAME -AdpBbuCmd -BbuLearn -a$1 > /dev/null
    if [ $? -eq 0 ]; then
    echo "`date`  Adapter$1:Battery refresh start." >> $OUTPUT_LOG 2>&1
    exit 0
    fi
  fi
done

exit 1 

